% this function implements the nearest subspace method, with
% err=min|y-Da|_2^2, which is equal to |u_2*y|_2^2
% we use QR to reduce the time. According to the experiment QR can save 1/4
% time.
function err=NearSubspace(y, D)
% SVD on D
% [U S V]=svd(D);
% or QR
[U S]=qr(D);
% err
S=diag(S);
err=norm(y'*U(:, length(S>0)+1: end));
end