% this script demos the usage of the joint sparsity model (4) on the CMU
% PIE dataset. We pick the images of each subject, with different pose and
% illumination conditions. Common is generated from the images of same pose
% but under different illumination conditions. Low rank is still used to
% capture the illumination conditions
clear all;
clc;
%% ========================================================================
% variables and constants
% path
root_dir='V:\CMU_PIE\pie_jpg\';
source_dir={'nov_2000-dec_2000', 'oct_2000-nov_2000'};
target_dir='F:\MATLAB\CMU_PIE\';
num_pose=13;
num_light=21;
num_subject=68;
offset_invalid=2;
offset_width=9;
offset_height=12;
image_width=80;
image_height=60;
lambda=2.5;
tol=1e-6;
maxIter=100;
limem=1;
debug=0;
tau=1.25;
rho=1.5;
lambda=lambda/sqrt(image_height);
%% ========================================================================
% condition over poses with same subject
% omega=ones(num_pose, num_light);
% X=zeros(image_height*num_pose, image_width*num_light);
% cd(root_dir);
% for i=1: length(source_dir)
%     cd(source_dir{i});
%     subject_list=dir('*');
%     % remove the first two, which is '.' and '..'
%     for j=3: length(subject_list)
%         % for each subject
%         if (subject_list(j).isdir)
%             cd(subject_list(j).name);
%             cd('illum');
%             % scan all the images, except the ones with 00, 01 and 23,
%             % which are totally black
%             image_list=dir('*.jpg');
%             t=1;
%             for k=1: num_pose
%                 % skip the first two;
%                 t=t+offset_invalid;
%                 for l=1: num_light
%                     img=imread(image_list(t).name);
%                     img=imresize(rgb2gray(img(offset_height: end, offset_width: end, :)), [image_height, image_width]);
%                     X((k-1)*image_height+1: k*image_height, (l-1)*image_width+1: l*image_width)=log(double(img)+1);
%                     t=t+1;
%                 end
%                 % skip the last one;
%                 t=t+1;
%             end
%             % do the decomposition
%             [C_hat, A_hat, E_hat, output]=JointMC7(X, [image_height, image_width, ...
%                 num_pose, num_light], omega, lambda, tol, ...
%                 maxIter, limem, debug, tau, rho);
%             % save the result
%             matrix2im(exp(C_hat), [target_dir subject_list(j).name '_C_hat.tif'], 16);
%             matrix2im(exp(A_hat), [target_dir subject_list(j).name '_A_hat.tif'], 16);
%             matrix2im(exp(E_hat), [target_dir subject_list(j).name '_E_hat.tif'], 16);
%             matrix2im(exp(X)-1, [target_dir subject_list(j).name '_X_org.tif'], 16);
%             for k=1: num_pose
%                 for l=1: num_light
%                     t=(k-1)*(num_light+2)+l+2;
%                     X((k-1)*image_height+1: k*image_height, (l-1)*image_width+1: l*image_width)=...
%                         exp(C_hat(:, (k-1)*image_width+1: k*image_width)+...
%                         A_hat(:, (l-1)*image_width+1: l*image_width));
%                 end
%             end
%             matrix2im(X, [target_dir subject_list(j).name '_X_rec.tif'], 16);
%             cd('..');
%             cd('..');
%         end
%     end
%     cd('..');
% end
%% ========================================================================
% condition over subjects with same pose
omega=ones(num_subject, num_light);
X=zeros(image_height*num_subject, image_width*num_light);
cd(root_dir);
for k=[2 5 7 9 11 14 22 25 27 29 31 34 37]
    t=1;
    % for two time sessions
    for i=1: length(source_dir)
        cd(source_dir{i});
        subject_list=dir('*');
        % remove the first two, which is '.' and '..'
        for j=3: length(subject_list)
            % for each subject
            if (subject_list(j).isdir)
                cd(subject_list(j).name);
                cd('illum');
                % scan all the images, except the ones with 00, 01 and 23,
                % which are totally black
                image_list=dir([num2str(k, '%02d'), '*.jpg']);
                for l=1: num_light
                    img=imread(image_list(l+2).name);
                    img=imresize(rgb2gray(img(offset_height: end, offset_width: end, :)), [image_height, image_width]);
                    X((t-1)*image_height+1: t*image_height, (l-1)*image_width+1: l*image_width)=log(double(img)+1);
                end
                cd('..');
                cd('..');
                t=t+1;
            end
        end
        cd('..');
    end
    % do the decomposition
    [C_hat, A_hat, E_hat, output]=JointMC7(X, [image_height, image_width, ...
        num_subject, num_light], omega, lambda, tol, ...
        maxIter, limem, debug, tau, rho);
    % save the result
    matrix2im(exp(C_hat), [target_dir num2str(k, '%02d') '_C_hat.tif'], 16);
    matrix2im(exp(A_hat), [target_dir num2str(k, '%02d') '_A_hat.tif'], 16);
    matrix2im(exp(E_hat), [target_dir num2str(k, '%02d') '_E_hat.tif'], 16);
    matrix2im(exp(X)-1, [target_dir num2str(k, '%02d') '_X_org.tif'], 16);
    for j=1: num_subject
        for l=1: num_light
            X((j-1)*image_height+1: j*image_height, (l-1)*image_width+1: l*image_width)=...
                exp(C_hat(:, (j-1)*image_width+1: j*image_width)+...
                A_hat(:, (l-1)*image_width+1: l*image_width));
        end
    end
    matrix2im(X, [target_dir num2str(k, '%02d') '_X_rec.tif'], 16);
end