% generate mask
patch_mask=cell(1, 25);
if strcmpi(option.dataset, 'AR')
    l=1;
    for i=[1 10 19 28 38]
        for j=[1 8 15 22 27]
            patch_tmp=zeros(option.height, option.width);
            patch_tmp(i: i+17, j: j+13)=1;
            patch_mask{l}=repmat(patch_tmp(:)==1, 1, size(A_hat, 2));
            l=l+1;
        end
    end
elseif strcmpi(option.dataset, 'YaleB')
    l=1;
    for i=[1 9 17 25 33]
        for j=[1 8 15 22 29]
            patch_tmp=zeros(option.height, option.width);
            patch_tmp(i: i+15, j: j+13)=1;
            patch_mask{l}=repmat(patch_tmp(:)==1, [], size(A_hat, 2));
            l=l+1;
        end
    end
end
clear l i j patch_tmp;

%% ========================================================================
% preprocessing
X=zeros(option.width*option.height, 64);
for i=1: size(X, 2)
    % read in the image
    img=imread(dirlist(i).name);
    % color image?
    if size(img, 3)~=1
        img=0.2989*img(:, :, 1)+0.5870*img(:, :, 2)+0.1140*img(:, :, 3);
    end
    % resize the image?
    if option.height~=0 && option.width~=0
        img=imresize(img, [option.height, option.width]);
    end
    height=size(img, 1);
    width=size(img, 2);
    % some preprocessing may be need here
    img=double(img);
    % normalization
    switch option.mode
        case 0
            % do nothing
        case 1
            % unit l2-norm for each image
            img=img/norm(img, 'fro');
        case 2
            % zero mean and unit l2-norm for each image
            img=img-mean(img(:));
            img=img/norm(img, 'fro');
        case 3
            % zero mean and unit std for eac dimension
            img=img-mean(img(:));
            img=img/std(img(:));
        case 4
            % zerp mean
            img=img-mean(img(:));
    end
    X(:, i)=img(:);
end
clear i height width img;